#include "ma_remove_cursed_items"

const int PRICE = 750;
const int PARTY = FALSE;
const string MESSAGE = "Not enough gold";
const string ERROR = "You're not cursed";

void main(int iTarget)
{
	object oTarget = IntToObject(iTarget);
	effect eLink = EffectLinkEffects(EffectVisualEffect(VFX_IMP_HEALING_S), EffectHeal(d8(4)+9));
	int bValid = FALSE;
	
	if (GetGold(oTarget) >= PRICE)
	{
		if(PARTY)
		{
			object oCurrent = GetFirstFactionMember(oTarget, FALSE);
			while(GetIsObjectValid(oCurrent))
			{
			    effect eCurse = GetFirstEffect(oCurrent);
			    effect eVis = EffectVisualEffect(VFX_IMP_REMOVE_CONDITION);
			    while(GetIsEffectValid(eCurse))
			    {
			        if (GetEffectType(eCurse) == EFFECT_TYPE_CURSE)
			        {
			            RemoveEffect(oCurrent, eCurse);
			            bValid = TRUE;
			        }
			        GetNextEffect(oCurrent);
					
					if(bValid)
						ApplyEffectToObject(DURATION_TYPE_INSTANT, eVis, oCurrent);
			    }
				
				RemoveCursedItems(oCurrent);
				oCurrent = GetNextFactionMember(oTarget, FALSE);
			}
		}
		else
		{
		    effect eCurse = GetFirstEffect(oTarget);
		    effect eVis = EffectVisualEffect(VFX_IMP_REMOVE_CONDITION);
		    while(GetIsEffectValid(eCurse))
		    {
		        if (GetEffectType(eCurse) == EFFECT_TYPE_CURSE)
		        {
		            RemoveEffect(oTarget, eCurse);
		            bValid = TRUE;
		        }
		        GetNextEffect(oTarget);
				
				if (bValid)
					ApplyEffectToObject(DURATION_TYPE_INSTANT, eVis, oTarget);
		    }
			
			RemoveCursedItems(oTarget);
		}
		
		if (bValid)
			TakeGoldFromCreature(PRICE, oTarget, TRUE);
		else
			SendMessageToPC(oTarget, ERROR);
	}
	else
		SendMessageToPC(oTarget, MESSAGE);
}